
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_movementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.create(
            {
                id: data.id || undefined,
        
        moved_at: data.moved_at
        ||
        null
            ,
            
        movement_type: data.movement_type
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_cost_ht: data.unit_cost_ht
        ||
        null
            ,
            
        reference: data.reference
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_movements.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await stock_movements.setProduct( data.product || null, {
            transaction,
        });
        
        await stock_movements.setWarehouse( data.warehouse || null, {
            transaction,
        });
        

        

        

        return stock_movements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_movementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                moved_at: item.moved_at
            ||
            null
            ,
            
                movement_type: item.movement_type
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_cost_ht: item.unit_cost_ht
            ||
            null
            ,
            
                reference: item.reference
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_movements = await db.stock_movements.bulkCreate(stock_movementsData, { transaction });

        // For each item created, replace relation files
        

        return stock_movements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const stock_movements = await db.stock_movements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.moved_at !== undefined) updatePayload.moved_at = data.moved_at;
        
        
        if (data.movement_type !== undefined) updatePayload.movement_type = data.movement_type;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_cost_ht !== undefined) updatePayload.unit_cost_ht = data.unit_cost_ht;
        
        
        if (data.reference !== undefined) updatePayload.reference = data.reference;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_movements.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await stock_movements.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await stock_movements.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.warehouse !== undefined) {
            await stock_movements.setWarehouse(
              
              data.warehouse,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_movements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_movements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_movements) {
                await record.destroy({transaction});
            }
        });


        return stock_movements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findByPk(id, options);

        await stock_movements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_movements.destroy({
            transaction
        });

        return stock_movements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findOne(
            { where },
            { transaction },
        );

        if (!stock_movements) {
            return stock_movements;
        }

        const output = stock_movements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await stock_movements.getOrganization({
            transaction
        });
        
        
        output.product = await stock_movements.getProduct({
            transaction
        });
        
        
        output.warehouse = await stock_movements.getWarehouse({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.warehouses,
        as: 'warehouse',
        
        where: filter.warehouse ? {
          [Op.or]: [
            { id: { [Op.in]: filter.warehouse.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.warehouse.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_movements',
                        'reference',
                        filter.reference,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_movements',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.moved_atRange) {
                const [start, end] = filter.moved_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    moved_at: {
                    ...where.moved_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    moved_at: {
                    ...where.moved_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_cost_htRange) {
                const [start, end] = filter.unit_cost_htRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_cost_ht: {
                    ...where.unit_cost_ht,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_cost_ht: {
                    ...where.unit_cost_ht,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.movement_type) {
                where = {
                    ...where,
                movement_type: filter.movement_type,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_movements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_movements',
                        'reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_movements.findAll({
            attributes: [ 'id', 'reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reference,
        }));
    }

    
};

